
//=============================================================================*/

#define ADC1_DR_Address                0x40012440

/*********йADУ׼****************/

#define N 32 //ÿͨ32  M<=32
#define M 2 //ͨ

u16 AD_Value[N][M]; //DMAдֵ
u16 After_filter[M]; //ֵ֮


void GPIO_init(void);
void USART1_Init(void);
void ADC_init(void);
void TIMER3_Init(void);		//ʱ1ʼ		ڽ
void TIMER14_Init(void);		//AHۼ





void system_init(void)
{		GPIO_init();
		ADC_init();
		USART1_Init();
		TIMER14_Init();
	
		//IWDG_Configuration(781);
}


void GPIO_init(void)
{	GPIO_InitTypeDef  GPIO_InitStructure;
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE);

	//ʼPA  AD
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AN;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL ;
  GPIO_Init(GPIOA, &GPIO_InitStructure);
}




/* USARTʼ */
void USART1_Init(void)
{	GPIO_InitTypeDef GPIO_InitStructure;
	USART_InitTypeDef USART_InitStructure;
		
	//RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA, ENABLE);  //ʹGPIOAʱ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);//ʹUSARTʱ
	/* USART1Ķ˿ */
	GPIO_PinAFConfig(GPIOA, GPIO_PinSource9, GPIO_AF_1);//PA9ɵڶ	TX
	GPIO_PinAFConfig(GPIOA, GPIO_PinSource10, GPIO_AF_1);//PA10ɵڶ  RX	

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9 | GPIO_Pin_10;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	

	/* USART1Ļ */
	USART_InitStructure.USART_BaudRate =115200;              //
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;

	USART_Init(USART1, &USART_InitStructure);		
	USART_Cmd(USART1, ENABLE);                             //ʹUSART1
				
}

void USART_ENABLE_CMD(void)
{	NVIC_InitTypeDef NVIC_InitStruct;
	/* USART1NVICж */
	NVIC_InitStruct.NVIC_IRQChannel = USART1_IRQn;
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x03;
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStruct);

	
	if(USART_GetFlagStatus(USART1, USART_FLAG_ORE) != RESET) USART_ClearFlag(USART1, USART_FLAG_ORE); 
	if(USART_GetITStatus(USART1, USART_IT_RXNE) != RESET) USART_ClearITPendingBit(USART1, USART_IT_RXNE);

	
	USART_ITConfig(USART1,USART_IT_RXNE,ENABLE);           //ʹܽж
	USART_ITConfig(USART1, USART_IT_TC, ENABLE);	

}


void ADC_init(void)
{	ADC_InitTypeDef     ADC_InitStruct;
	DMA_InitTypeDef     DMA_InitStruct;
	
	
	
	/* ADC1 Periph clock enable */
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1, ENABLE);
  /* DMA1 clock enable */
  RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1 , ENABLE);

	ADC_DeInit(ADC1);
 
	ADC_StructInit(&ADC_InitStruct);
  
  /* Configure the ADC1 in continous mode withe a resolutuion equal to 12 bits  */
  ADC_InitStruct.ADC_Resolution = ADC_Resolution_12b;
  ADC_InitStruct.ADC_ContinuousConvMode = ENABLE; 
  ADC_InitStruct.ADC_ExternalTrigConvEdge = ADC_ExternalTrigConvEdge_None;
  ADC_InitStruct.ADC_DataAlign = ADC_DataAlign_Right;
  ADC_InitStruct.ADC_ScanDirection = ADC_ScanDirection_Upward;
//	ADC_InitStruct.ADC_NbrOfChannel=M;
  ADC_Init(ADC1, &ADC_InitStruct); 
	 ADC_TempSensorCmd(ENABLE);
 
//   /* Convert the ADC1 temperature sensor  with 55.5 Cycles as sampling time */ 
//   ADC_ChannelConfig(ADC1, ADC_Channel_TempSensor , ADC_SampleTime_55_5Cycles);  
//   ADC_TempSensorCmd(ENABLE);
  
  // Convert the ADC1 Vref  with 55.5 Cycles as sampling time  								//	After_filter 
  ADC_ChannelConfig(ADC1, ADC_Channel_0  , ADC_SampleTime_239_5Cycles); //1	PA0 A1		1					
  ADC_ChannelConfig(ADC1, ADC_Channel_1  , ADC_SampleTime_239_5Cycles); //2	PA1	A2		2					
//  ADC_ChannelConfig(ADC1, ADC_Channel_2  , ADC_SampleTime_239_5Cycles); //3 PA2 5V 		3					
//  ADC_ChannelConfig(ADC1, ADC_Channel_3  , ADC_SampleTime_239_5Cycles); //4	PA3 V1		4					
//  ADC_ChannelConfig(ADC1, ADC_Channel_4  , ADC_SampleTime_239_5Cycles); //5 PA4 V2		5					
 // ADC_ChannelConfig(ADC1, ADC_Channel_17  , ADC_SampleTime_239_5Cycles); 	//1.2				0					
	
	
   ADC_VrefintCmd(ENABLE);
  	
	
	
	
	/* DMA1 Channel1 Config */
  DMA_DeInit(DMA1_Channel1);
  DMA_InitStruct.DMA_PeripheralBaseAddr = (uint32_t)ADC1_DR_Address;
  DMA_InitStruct.DMA_MemoryBaseAddr = (u32)&AD_Value;
  DMA_InitStruct.DMA_DIR = DMA_DIR_PeripheralSRC;
  DMA_InitStruct.DMA_BufferSize =N*M;
  DMA_InitStruct.DMA_PeripheralInc = DMA_PeripheralInc_Disable;
  DMA_InitStruct.DMA_MemoryInc = DMA_MemoryInc_Enable;
  DMA_InitStruct.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord;
  DMA_InitStruct.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord;
  DMA_InitStruct.DMA_Mode = DMA_Mode_Circular;
  DMA_InitStruct.DMA_Priority = DMA_Priority_High;
  DMA_InitStruct.DMA_M2M = DMA_M2M_Disable;
  DMA_Init(DMA1_Channel1, &DMA_InitStruct);

	
	
	 /* DMA1 Channel1 enable */
  DMA_Cmd(DMA1_Channel1, ENABLE);
  
//   /* ADC DMA request in circular mode */
  ADC_DMARequestModeConfig(ADC1, ADC_DMAMode_Circular);
  
  /* Enable ADC_DMA */
  ADC_DMACmd(ADC1, ENABLE);  

	 /* Initialize ADC structure */
  
  /* ADC Calibration */
  ADC_GetCalibrationFactor(ADC1);
  //ADC_DMACmd(ADC1, ENABLE);
  /* Enable ADC1 */
  ADC_Cmd(ADC1, ENABLE);     
  
  /* Wait the ADCEN falg */
  while(!ADC_GetFlagStatus(ADC1, ADC_FLAG_ADEN)); 
  
  /* ADC1 regular Software Start Conv */ 
  ADC_StartOfConversion(ADC1);


}




void TIMER14_Init(void)		//AHۼ
{	
	TIM_TimeBaseInitTypeDef TIM_TimeBaseStructure;
 	NVIC_InitTypeDef NVIC_InitStructure; 
	
 	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM14, ENABLE);

	NVIC_InitStructure.NVIC_IRQChannel = TIM14_IRQn;//ָжԴ
	NVIC_InitStructure.NVIC_IRQChannelPriority = 0;// ָӦȼ1
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);

 	TIM_TimeBaseStructure.TIM_Period=500;
 	TIM_TimeBaseStructure.TIM_Prescaler=6400;
	TIM_TimeBaseStructure.TIM_ClockDivision = 0;	
 	TIM_TimeBaseStructure.TIM_CounterMode=TIM_CounterMode_Up; //ϼģʽ
 	
	TIM_TimeBaseInit(TIM14, &TIM_TimeBaseStructure);
 	TIM_ITConfig(TIM14,TIM_IT_Update,ENABLE);

 	TIM_Cmd(TIM14, ENABLE); //ʱ
	
}





void TIM14_IRQHandler(void)	  //ˢ
{	//һ1
	if(TIM_GetITStatus(TIM14 , TIM_IT_Update) == SET)
	{ 	sec++;
    	TIM_ClearITPendingBit(TIM14, TIM_FLAG_Update); //ж
	}
}

